﻿@{ ViewData["Title"] = "Create Media";
@model media_model.Media.MediaData
}

<h3 class="m-3 text-dark">Create - Media</h3>
<div class="col-lg-12 col-md-12 col-sm-12 col-xs-12" id="x">
    @using (Html.BeginForm("create", "media", FormMethod.Post, new { enctype = "multipart/form-data", onsubmit = "if(!(CreateMedia(this))) return false;" }))
    {
    <div class="card card-primary card-outline">
        <div class="card-header">
            <h5>Please fill in all required information.</h5>
        </div>
        <div class="card-body">
            <div class="row">
                <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12">
                    <div class="form-group" id="upload">
                        @Html.LabelFor(m => m.FileBytes, new { @class = "control-label f-left lh" })<br />

                        <div class="file-field">
                            <div class="z-depth-1-half mb-4 mt-4">
                                <img src="~/dist/img/placeholder.jpg" id="fileImg" class="img-fluid center"
                                     alt="" width="300">
                            </div>
                        </div>

                        <div class="input-group">
                            <div class="input-group-prepend">
                                <span class="input-group-text" id="inputGroupFileAddon01">Upload File</span>
                            </div>
                            <div class="custom-file">
                                <input type="file" id="file" accept=".jpg,.jpeg,.png,.mp4">
                                <label id="lbFile" class="custom-file-label" for="file">Choose file</label>
                                @Html.TextBoxFor(m => m.FileBytes, new { @type = "hidden" });
                                @Html.TextBoxFor(m => m.Thumbnail, new { @type = "hidden" });
                                <input id="fileSrc" type="hidden" />
                            </div>
                        </div>
                        <div id="fileImg"></div>
                    </div>
                    <div class="form-group">
                        @Html.LabelFor(m => m.FileName, new { @class = "control-label f-left lh" })
                        @Html.TextBoxFor(m => m.FileName, new { @class = "form-control" })
                    </div>
                    <div class="form-group">
                        @Html.LabelFor(m => m.FileType, new { @class = "control-label f-left lh" })
                        @Html.TextBoxFor(m => m.FileType, new { @class = "form-control", @readonly = "true" })
                    </div>
                    <div class="form-group">
                        @Html.LabelFor(m => m.FileSize, new { @class = "control-label f-left lh" })
                        @Html.TextBoxFor(m => m.FileSize, new { @class = "form-control", @readonly = "true" })
                    </div>
                </div>
            </div>
        </div>
        <div class="card-footer">
            <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12">
                <div class="form-group">
                    <input type="submit" value="Create" class="btn btn-primary col-lg-3 col-md-4 col-sm-4 col-xs-12" onclick="return " />
                    <input type="button" value="Cancel" class="btn btn-default col-lg-3 col-md-4 col-sm-4 col-xs-12" onclick="history.go(-1)" />
                </div>
            </div>
        </div>
    </div>
    }
</div>

@section Scripts {
    <script>

        $(document).ready(function () {
            $('input[type="file"]').change(function (e) {
                var fileName = e.target.files[0].name;
                $('.custom-file-label').html(fileName);
            });

            document.getElementById('file').addEventListener('change', function (event) {
                //Show loading
                Loading(true);

                setValue("Thumbnail", "");
                document.getElementById('fileImg').src = '@Url.Content("~/dist/img/placeholder.jpg")'
                var file = event.target.files[0];
                var FileName = document.getElementById('FileName');
                var FileType = document.getElementById('FileType');
                var FileSize = document.getElementById('FileSize');

                if (!"image/jpeg,image/jpg,image/png,video/mp4".includes(file.type) || file.type == "") {
                    clearValue();
                    alert("File type is not valid.");
                    return;
                }

                if (file.size > 1048576 * 50) {
                    clearValue();
                    alert("File size must be less then 50mb.");
                    return;
                }

                var fileReader = new FileReader();
                
                if (file.type.match('image')) {
                    fileReader.onload = function () {
                        //var img = document.createElement('img');
                        //img.id = "FileImage";
                        //img.src = fileReader.result;
                        document.getElementById('FileBytes').value = fileReader.result.split(',')[1];
                        document.getElementById('fileImg').src = fileReader.result;
                        resizeImage(fileReader.result, 90, function (dat) {
                            setValue("Thumbnail", dat);
                        });
                    };
                    fileReader.readAsDataURL(file);
                } else {
                    fileReader.onload = function () {
                        var base64 = btoa(
                            new Uint8Array(fileReader.result)
                                .reduce((data, byte) => data + String.fromCharCode(byte), '')
                        );
                        document.getElementById('FileBytes').value = base64;

                        var blob = new Blob([fileReader.result], { type: file.type });
                        var url = URL.createObjectURL(blob);
                        var video = document.createElement('video');
                        var timeupdate = function () {
                            if (snapImage()) {
                                video.removeEventListener('timeupdate', timeupdate);
                                video.pause();
                            }
                        };
                        video.addEventListener('loadeddata', function () {
                            if (snapImage()) {
                                video.removeEventListener('timeupdate', timeupdate);
                            }
                        });
                        var snapImage = function () {
                            var canvas = document.createElement('canvas');
                            canvas.width = video.videoWidth;
                            canvas.height = video.videoHeight;
                            canvas.getContext('2d').drawImage(video, 0, 0, canvas.width, canvas.height);
                            var image = canvas.toDataURL();
                            var success = image.length > 100000;
                            if (success) {
                                //var img = document.createElement('img');
                                //img.src = image;
                                document.getElementById('fileImg').src = image;
                                resizeImage(image, 90, function (dat) {
                                    setValue("Thumbnail", dat);
                                });
                                
                                URL.revokeObjectURL(url);

                                
                            }

                            return success;
                        };
                        video.addEventListener('timeupdate', timeupdate);
                        video.preload = 'metadata';
                        video.src = url;
                        // Load video in Safari / IE11
                        video.muted = true;
                        video.playsInline = true;
                        video.play();

                    };
                    fileReader.readAsArrayBuffer(file);
                }
                
                FileName.value = document.getElementById('lbFile').innerText.replace(".jpg", "").replace(".png", "").replace(".jpeg", "").replace(".mp4", "");
                FileType.value = file.type;
                FileSize.value = parseFloat(file.size / 1048576).toFixed(2); //mb
                
            });
        });

        function validateData() {
            //Show loading
            Loading(true);
            if (getValue("FileName") == "" && getValue("FileType") == "" && getValue("FileSize") == "") {
                alert("Please upload your media file.");
                Loading(false);
                return false;
            }
            else if (getValue("FileName") == "") {
                alert("Please fill in data \"FileName\".");
                Loading(false);
                return false;
            }
            else {
                return true;
            }
        }

        function CreateMedia(formData) {
            var result = false;
            if (validateData()) {
                var ajaxConfig = {
                    type: "POST",
                    url: "/Media/Create",
                    data: new FormData(formData),
                    success: function (result) {
                        if (result.code == "0") {
                            window.location.href = "/home/index";
                            result = true;
                        }
                        else {
                            alert(result.message);
                            Loading(false);
                        }
                    },
                }
                if ($(formData).attr('enctype') == "multipart/form-data") {
                    ajaxConfig["contentType"] = false;
                    ajaxConfig["processData"] = false;
                }
                $.ajax(ajaxConfig);
            }
            return result;
        }

        function clearValue() {
            FileName.value = "";
            FileType.value = "";
            FileSize.value = "";
            $('.custom-file-label').html("");
            setValue("file", "");
            Loading(false);
        }
    </script>
}